// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/SplitDocuments.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class SplitDocuments extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inMain = 2;
  public static final int inFooter = 4;
  public static final int inRegistrato = 6;
  public static final int inUfficio = 8;
  public static final int inAttachment = 10;
  public static final int inGenericAttachment = 12;
  public static final int inSkip = 14;
  public static final int inPre = 16;
  public static final int inTable = 18;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  3,  3,  4,  4,  5,  5,  6,  6, 
     7,  7,  8, 8
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\266\u0200\10\u0500\u1020\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\3\1\4\1\2\22\0\1\1"+
    "\5\0\1\5\6\0\1\6\1\7\1\10\1\11\1\12"+
    "\1\13\3\14\4\15\1\16\1\17\1\20\1\0\1\21"+
    "\2\0\1\22\1\23\1\24\1\25\1\26\1\27\1\30"+
    "\1\31\1\32\1\33\1\34\1\35\1\36\1\37\1\40"+
    "\1\41\1\42\1\43\1\44\1\45\1\46\1\47\1\33"+
    "\1\50\1\33\1\51\1\0\1\6\1\0\1\52\2\0"+
    "\1\53\1\23\1\54\1\55\1\56\1\27\1\30\1\31"+
    "\1\57\1\33\1\34\1\60\1\36\1\61\1\62\1\63"+
    "\1\42\1\64\1\44\1\65\1\46\1\66\3\33\1\67"+
    "\12\0\1\3\44\0\1\52\5\0\1\52\11\0\1\52"+
    "\165\0\2\70\115\0\1\71\u0182\0\1\1\45\0\2\3"+
    "\u0100\0\1\72\325\0\u0100\3";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\11\0\2\1\4\2\2\3\2\1\4\2\6\1\3\2"+
    "\111\0\1\4\16\0\1\5\10\0\1\6\40\0\1\7"+
    "\25\0\1\10\32\0\1\11\44\0\1\12\6\0\1\13"+
    "\33\0\20\14\4\0\1\15\6\0\2\16\11\0\2\17"+
    "\30\0\2\16\11\0\2\17\25\0\1\20\3\0\1\16"+
    "\6\0\1\21\3\0\1\17\54\0\1\22\1\0\1\22"+
    "\1\23\5\0\2\24\45\0\2\22\4\0\2\24\13\0"+
    "\2\14\23\0\2\16\7\0\1\22\5\0\1\24\26\0"+
    "\2\16\1\0\1\25\33\0\2\16\27\0\3\16\1\0"+
    "\1\26\14\0\2\16\11\0\2\16\4\0\2\16\2\0"+
    "\1\16\1\0\2\16\1\0\1\16\6\0\1\27";

  private static int [] zzUnpackAction() {
    int [] result = new int[674];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\73\0\166\0\261\0\354\0\u0127\0\u0162\0\u019d"+
    "\0\u01d8\0\u0213\0\u024e\0\u0213\0\u0289\0\u02c4\0\u02ff\0\u033a"+
    "\0\u0375\0\u03b0\0\u03eb\0\u0426\0\u0461\0\u049c\0\u04d7\0\u0512"+
    "\0\u054d\0\u0588\0\u05c3\0\u05fe\0\u0639\0\u0674\0\u06af\0\u06ea"+
    "\0\u0725\0\u0289\0\u02c4\0\u0760\0\u079b\0\u07d6\0\u0811\0\u03b0"+
    "\0\u084c\0\u0887\0\u08c2\0\u08fd\0\u0938\0\u0973\0\u09ae\0\u0512"+
    "\0\u09e9\0\u0a24\0\u0a5f\0\u0a9a\0\u0ad5\0\u0b10\0\u0b4b\0\u0b86"+
    "\0\u0bc1\0\u0bfc\0\u0c37\0\u0c72\0\u0cad\0\u0ce8\0\u0d23\0\u0d5e"+
    "\0\u0d99\0\u0dd4\0\u0e0f\0\u0e4a\0\u0e85\0\u0ec0\0\u0efb\0\u0f36"+
    "\0\u0f71\0\u0fac\0\u0fe7\0\u1022\0\u105d\0\u1098\0\u10d3\0\u110e"+
    "\0\u1149\0\u1184\0\u11bf\0\u11fa\0\u1235\0\u1270\0\u12ab\0\u12e6"+
    "\0\u1321\0\u135c\0\u1397\0\u13d2\0\u140d\0\u1448\0\u1483\0\u14be"+
    "\0\u14f9\0\u1534\0\u156f\0\u15aa\0\u15e5\0\u1620\0\u165b\0\u1696"+
    "\0\u16d1\0\u0213\0\u170c\0\u1747\0\u1782\0\u17bd\0\u17f8\0\u1833"+
    "\0\u186e\0\u18a9\0\u18e4\0\u191f\0\u195a\0\u1995\0\u19d0\0\u1a0b"+
    "\0\u1a46\0\u1a81\0\u1abc\0\u1af7\0\u1b32\0\u1b6d\0\u1ba8\0\u1be3"+
    "\0\u1c1e\0\u0289\0\u1c59\0\u1c94\0\u1ccf\0\u1d0a\0\u1d45\0\u1d80"+
    "\0\u1dbb\0\u1df6\0\u1e31\0\u1e6c\0\u1ea7\0\u1ee2\0\u1f1d\0\u1f58"+
    "\0\u1f93\0\u1fce\0\u2009\0\u2044\0\u207f\0\u20ba\0\u20f5\0\u2130"+
    "\0\u216b\0\u21a6\0\u21e1\0\u221c\0\u2257\0\u2292\0\u22cd\0\u2308"+
    "\0\u2343\0\u237e\0\u0213\0\u23b9\0\u23f4\0\u242f\0\u246a\0\u24a5"+
    "\0\u24e0\0\u251b\0\u2556\0\u2591\0\u25cc\0\u2607\0\u2642\0\u267d"+
    "\0\u26b8\0\u26f3\0\u272e\0\u2769\0\u27a4\0\u27df\0\u281a\0\u2855"+
    "\0\u0213\0\u2890\0\u28cb\0\u2906\0\u2941\0\u297c\0\u29b7\0\u29f2"+
    "\0\u2a2d\0\u2a68\0\u2aa3\0\u2ade\0\u2b19\0\u2b54\0\u2b8f\0\u2bca"+
    "\0\u2c05\0\u2c40\0\u2c7b\0\u2cb6\0\u2cf1\0\u2d2c\0\u2d67\0\u2da2"+
    "\0\u2ddd\0\u2e18\0\u2e53\0\u0213\0\u2e8e\0\u2ec9\0\u2f04\0\u2f3f"+
    "\0\u2f7a\0\u2fb5\0\u2ff0\0\u302b\0\u3066\0\u30a1\0\u30dc\0\u3117"+
    "\0\u3152\0\u318d\0\u31c8\0\u3203\0\u323e\0\u3279\0\u32b4\0\u32ef"+
    "\0\u332a\0\u3365\0\u33a0\0\u33db\0\u3416\0\u3451\0\u348c\0\u34c7"+
    "\0\u3502\0\u353d\0\u3578\0\u35b3\0\u35ee\0\u3629\0\u3664\0\u369f"+
    "\0\u0213\0\u36da\0\u3715\0\u3750\0\u378b\0\u37c6\0\u3801\0\u0213"+
    "\0\u383c\0\u3877\0\u38b2\0\u38ed\0\u3928\0\u3963\0\u399e\0\u39d9"+
    "\0\u3a14\0\u3a4f\0\u3a8a\0\u3ac5\0\u3b00\0\u3b3b\0\u3b76\0\u3bb1"+
    "\0\u3bec\0\u3c27\0\u3c62\0\u3c9d\0\u3cd8\0\u3d13\0\u3d4e\0\u3d89"+
    "\0\u3dc4\0\u3dff\0\u3e3a\0\u3e75\0\u3eb0\0\u3eeb\0\u3f26\0\u0213"+
    "\0\u3f61\0\u3f9c\0\u3fd7\0\u4012\0\u404d\0\u4088\0\u40c3\0\u40fe"+
    "\0\u4139\0\u4174\0\u41af\0\u40c3\0\u41ea\0\u4225\0\u4260\0\u0213"+
    "\0\u429b\0\u42d6\0\u4311\0\u434c\0\u4387\0\u43c2\0\u43fd\0\u4438"+
    "\0\u4473\0\u44ae\0\u44e9\0\u4524\0\u455f\0\u459a\0\u45d5\0\u4610"+
    "\0\u464b\0\u4686\0\u46c1\0\u46fc\0\u4737\0\u4772\0\u47ad\0\u47e8"+
    "\0\u4823\0\u485e\0\u4899\0\u48d4\0\u490f\0\u494a\0\u4985\0\u49c0"+
    "\0\u49fb\0\u4a36\0\u4a71\0\u4aac\0\u4ae7\0\u4b22\0\u4b5d\0\u4b98"+
    "\0\u4bd3\0\u4c0e\0\u4c49\0\u4c84\0\u4cbf\0\u4cfa\0\u4d35\0\u4d70"+
    "\0\u4dab\0\u4de6\0\u4e21\0\u4e5c\0\u4e97\0\u4ed2\0\u4f0d\0\u4f48"+
    "\0\u4f83\0\u4fbe\0\u4ff9\0\u5034\0\u506f\0\u50aa\0\u50e5\0\u5120"+
    "\0\u515b\0\u5196\0\u51d1\0\u520c\0\u5247\0\u5282\0\u52bd\0\u52f8"+
    "\0\u5333\0\u536e\0\u53a9\0\u53e4\0\u541f\0\u0213\0\u545a\0\u4c84"+
    "\0\u5495\0\u54d0\0\u550b\0\u5546\0\u5581\0\u55bc\0\u55f7\0\u5632"+
    "\0\u0213\0\u566d\0\u4f0d\0\u56a8\0\u56e3\0\u571e\0\u5759\0\u5794"+
    "\0\u57cf\0\u580a\0\u5845\0\u5880\0\u58bb\0\u58f6\0\u5931\0\u596c"+
    "\0\u59a7\0\u59e2\0\u5a1d\0\u5a58\0\u5a93\0\u5ace\0\u5b09\0\u5b44"+
    "\0\u5b7f\0\u5bba\0\u5bf5\0\u5c30\0\u5c6b\0\u5ca6\0\u5ce1\0\u5d1c"+
    "\0\u5d57\0\u5d92\0\u5dcd\0\u5e08\0\u5e43\0\u5e7e\0\u5eb9\0\u5ef4"+
    "\0\u5f2f\0\u5f6a\0\u5fa5\0\u5fe0\0\u601b\0\u6056\0\u6091\0\u60cc"+
    "\0\u6107\0\u6142\0\u617d\0\u61b8\0\u5632\0\u61f3\0\u622e\0\u6269"+
    "\0\u62a4\0\u62df\0\u631a\0\u6355\0\u6390\0\u63cb\0\u6406\0\u6441"+
    "\0\u647c\0\u64b7\0\u64f2\0\u652d\0\u6568\0\u65a3\0\u65de\0\u6619"+
    "\0\u6654\0\u668f\0\u66ca\0\u6705\0\u6740\0\u677b\0\u67b6\0\u67f1"+
    "\0\u682c\0\u6867\0\u68a2\0\u68dd\0\u6918\0\u6953\0\u698e\0\u69c9"+
    "\0\u6a04\0\u6a3f\0\u6a7a\0\u6ab5\0\u6af0\0\u6b2b\0\u6b66\0\u6ba1"+
    "\0\u6bdc\0\u6c17\0\u6c52\0\u6c8d\0\u6cc8\0\u6d03\0\u6d3e\0\u6d79"+
    "\0\u6db4\0\u6def\0\u6e2a\0\u6e65\0\u6ea0\0\u6edb\0\u6f16\0\u6f51"+
    "\0\u6f8c\0\u6fc7\0\u7002\0\u703d\0\u7002\0\u7078\0\u70b3\0\u70ee"+
    "\0\u7129\0\u7164\0\u719f\0\u71da\0\u7215\0\u7250\0\u728b\0\u72c6"+
    "\0\u7301\0\u733c\0\u7377\0\u73b2\0\u73ed\0\u7428\0\u7463\0\u749e"+
    "\0\u74d9\0\u7514\0\u754f\0\u758a\0\u75c5\0\u7600\0\u763b\0\u7676"+
    "\0\u6c17\0\u76b1\0\u76ec\0\u7727\0\u7762\0\u779d\0\u6d79\0\u77d8"+
    "\0\u7813\0\u784e\0\u7889\0\u78c4\0\u78ff\0\u793a\0\u7975\0\u79b0"+
    "\0\u79eb\0\u7a26\0\u7a61\0\u7a9c\0\u7ad7\0\u7b12\0\u7b4d\0\u7b88"+
    "\0\u7bc3\0\u7bfe\0\u7c39\0\u7c74\0\u7caf\0\u7cea\0\u7d25\0\u7d60"+
    "\0\u7d9b\0\u7dd6\0\u7600\0\u7e11\0\u7e4c\0\u7e87\0\u7ec2\0\u7efd"+
    "\0\u7f38\0\u7f73\0\u7fae\0\u7fe9\0\u8024\0\u805f\0\u809a\0\u80d5"+
    "\0\u8110\0\u814b\0\u8186\0\u81c1\0\u81fc\0\u8237\0\u8272\0\u82ad"+
    "\0\u82e8\0\u8323\0\u835e\0\u8399\0\u83d4\0\u840f\0\u844a\0\u8485"+
    "\0\u84c0\0\u84fb\0\u8536\0\u8571\0\u85ac\0\u85e7\0\u8622\0\u865d"+
    "\0\u8698\0\u86d3\0\u870e\0\u8749\0\u8784\0\u87bf\0\u87fa\0\u8835"+
    "\0\u8870\0\u88ab\0\u88e6\0\u8921\0\u895c\0\u8997\0\u89d2\0\u39d9"+
    "\0\u8a0d\0\u8a48\0\u8a83\0\u0213\0\u8abe\0\u8af9\0\u8b34\0\u8b6f"+
    "\0\u8baa\0\u8be5\0\u8c20\0\u8c5b\0\u8c96\0\u8cd1\0\u8d0c\0\u8d47"+
    "\0\u8d82\0\u8dbd\0\u8df8\0\u8e33\0\u8e6e\0\u8ea9\0\u8ee4\0\u8f1f"+
    "\0\u8f5a\0\u8f95\0\u8fd0\0\u900b\0\u9046\0\u9081\0\u90bc\0\u90f7"+
    "\0\u9132\0\u916d\0\u91a8\0\u91e3\0\u921e\0\u9259\0\u9294\0\u92cf"+
    "\0\u930a\0\u9345\0\u9380\0\u93bb\0\u93f6\0\u9431\0\u946c\0\u94a7"+
    "\0\u94e2\0\u0213";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[674];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\20\12\1\13\52\12\1\14\1\15\2\14\1\15\1\16"+
    "\12\14\1\17\52\14\1\12\1\20\1\21\1\12\1\20"+
    "\1\22\12\12\1\23\52\12\20\14\1\24\53\14\1\15"+
    "\2\14\1\15\1\16\12\14\1\25\52\14\1\12\1\26"+
    "\1\27\1\12\1\26\1\30\12\12\1\31\1\12\1\32"+
    "\1\12\1\33\14\12\1\34\3\12\1\35\25\12\20\14"+
    "\1\36\72\14\1\37\72\14\1\40\52\14\124\0\1\41"+
    "\42\0\1\42\2\0\1\42\1\43\12\0\1\44\111\0"+
    "\1\45\21\0\1\45\42\0\1\46\4\0\1\47\35\0"+
    "\1\20\1\21\1\0\1\20\1\50\12\0\1\51\53\0"+
    "\2\21\1\0\1\21\1\52\12\0\1\53\111\0\1\54"+
    "\21\0\1\54\42\0\1\55\4\0\1\47\44\0\1\56"+
    "\113\0\1\57\4\0\1\47\35\0\1\26\1\27\1\0"+
    "\1\26\1\60\12\0\1\44\53\0\2\27\1\0\1\27"+
    "\1\61\124\0\1\62\21\0\1\62\42\0\1\63\4\0"+
    "\1\47\60\0\1\64\106\0\1\65\75\0\1\66\72\0"+
    "\1\67\37\0\1\70\72\0\1\71\72\0\1\72\100\0"+
    "\1\73\105\0\1\74\4\0\1\47\57\0\1\75\65\0"+
    "\1\76\117\0\1\77\20\0\1\77\37\0\1\100\4\0"+
    "\1\47\73\0\1\101\21\0\1\101\42\0\1\102\64\0"+
    "\1\103\65\0\1\104\105\0\1\105\57\0\1\106\113\0"+
    "\1\107\21\0\1\107\34\0\1\110\65\0\1\111\100\0"+
    "\1\112\105\0\1\113\73\0\1\114\54\0\1\115\106\0"+
    "\1\116\65\0\1\117\72\0\1\120\102\0\1\121\21\0"+
    "\1\121\25\0\1\122\120\0\1\123\24\0\1\123\42\0"+
    "\1\124\3\0\1\125\15\0\1\124\1\0\1\125\41\0"+
    "\1\126\35\0\1\126\16\0\1\127\77\0\1\130\65\0"+
    "\1\131\120\0\1\132\24\0\1\132\42\0\1\133\3\0"+
    "\1\125\15\0\1\133\1\0\1\125\23\0\1\134\115\0"+
    "\1\135\3\0\1\125\15\0\1\135\1\0\1\125\30\0"+
    "\1\136\113\0\1\137\24\0\1\137\42\0\1\140\3\0"+
    "\1\125\15\0\1\140\1\0\1\125\45\0\1\141\101\0"+
    "\1\142\70\0\1\143\72\0\1\144\70\0\1\145\20\0"+
    "\1\145\24\0\1\146\72\0\1\147\55\0\1\150\2\0"+
    "\1\150\1\151\13\0\1\152\112\0\1\153\3\0\1\125"+
    "\15\0\1\153\1\0\1\125\46\0\1\154\21\0\1\154"+
    "\10\0\1\155\2\0\1\155\1\156\13\0\1\157\21\0"+
    "\1\160\20\0\1\160\30\0\1\161\30\0\1\161\35\0"+
    "\1\162\115\0\1\163\3\0\1\125\15\0\1\163\1\0"+
    "\1\125\51\0\1\164\24\0\1\164\42\0\1\165\21\0"+
    "\1\165\50\0\1\166\21\0\1\166\10\0\1\167\2\0"+
    "\1\167\1\170\13\0\1\171\21\0\1\160\20\0\1\160"+
    "\47\0\1\172\21\0\1\172\10\0\1\173\2\0\1\173"+
    "\1\174\13\0\1\175\21\0\1\160\20\0\1\160\52\0"+
    "\1\176\24\0\1\176\42\0\1\177\21\0\1\177\10\0"+
    "\1\200\2\0\1\200\1\201\13\0\1\202\21\0\1\160"+
    "\20\0\1\160\51\0\1\203\55\0\1\204\104\0\1\205"+
    "\77\0\1\206\61\0\1\207\35\0\1\207\41\0\1\210"+
    "\21\0\1\210\54\0\1\211\17\0\1\211\5\0\21\150"+
    "\1\152\51\150\37\0\1\212\21\0\1\212\54\0\1\160"+
    "\20\0\1\160\25\0\1\42\53\0\21\155\1\157\51\155"+
    "\37\0\1\213\21\0\1\213\12\0\1\42\2\0\1\42"+
    "\1\43\12\0\1\44\1\0\1\214\22\0\1\215\1\0"+
    "\1\216\3\0\1\214\11\0\1\215\1\216\32\0\1\217"+
    "\27\0\1\217\37\0\1\220\113\0\1\221\24\0\1\221"+
    "\2\0\1\222\2\0\1\222\1\223\13\0\1\224\21\0"+
    "\1\160\20\0\1\160\47\0\1\225\21\0\1\225\10\0"+
    "\1\222\2\0\1\222\1\223\13\0\1\224\70\0\1\20"+
    "\53\0\21\167\1\171\51\167\37\0\1\226\21\0\1\226"+
    "\12\0\1\227\1\230\1\0\1\227\1\231\12\0\1\232"+
    "\1\0\1\233\1\0\1\234\14\0\1\235\1\0\1\236"+
    "\1\0\1\237\1\240\4\0\1\241\10\0\1\236\1\242"+
    "\26\0\1\243\51\0\21\173\1\175\51\173\37\0\1\244"+
    "\21\0\1\244\12\0\1\42\2\0\1\42\1\43\12\0"+
    "\1\44\1\0\1\245\1\0\1\246\14\0\1\247\3\0"+
    "\1\250\5\0\1\251\11\0\1\252\46\0\1\253\21\0"+
    "\1\253\26\0\1\26\53\0\21\200\1\202\51\200\37\0"+
    "\1\254\21\0\1\254\36\0\1\255\104\0\1\256\57\0"+
    "\1\257\70\0\1\260\66\0\1\261\117\0\1\262\20\0"+
    "\1\262\30\0\1\263\30\0\1\263\42\0\1\264\72\0"+
    "\1\265\104\0\1\266\22\0\1\266\34\0\1\267\30\0"+
    "\1\267\51\0\1\270\24\0\1\270\10\0\1\270\2\0"+
    "\21\217\1\271\51\217\35\0\1\272\22\0\1\272\46\0"+
    "\1\273\35\0\1\273\21\222\1\224\51\222\37\0\1\274"+
    "\21\0\1\274\12\0\2\230\1\0\1\230\1\275\12\0"+
    "\1\276\1\0\1\277\1\0\1\234\14\0\1\235\1\0"+
    "\1\236\1\0\1\300\1\240\15\0\1\236\25\0\1\21"+
    "\76\0\1\301\50\0\1\227\1\230\1\0\1\227\1\231"+
    "\12\0\1\44\25\0\1\240\25\0\2\230\1\0\1\230"+
    "\1\275\40\0\1\240\63\0\1\302\21\0\1\302\21\0"+
    "\1\303\20\0\1\74\4\0\1\47\60\0\1\304\10\0"+
    "\1\305\22\0\1\305\52\0\1\306\75\0\1\307\55\0"+
    "\1\310\27\0\1\310\36\0\1\311\20\0\1\312\7\0"+
    "\1\311\46\0\1\313\100\0\1\305\22\0\1\305\34\0"+
    "\1\311\30\0\1\311\42\0\1\314\73\0\1\315\10\0"+
    "\1\316\22\0\1\316\52\0\1\317\75\0\1\320\51\0"+
    "\1\321\20\0\1\322\7\0\1\321\54\0\1\316\22\0"+
    "\1\316\34\0\1\321\30\0\1\321\36\0\1\27\76\0"+
    "\1\323\107\0\1\324\103\0\1\325\61\0\1\326\77\0"+
    "\1\255\71\0\1\327\24\0\1\327\27\0\1\330\27\0"+
    "\1\330\37\0\1\331\113\0\1\332\24\0\1\332\45\0"+
    "\1\333\24\0\1\333\36\0\1\334\22\0\1\334\35\0"+
    "\1\335\113\0\1\336\24\0\1\336\27\0\1\337\27\0"+
    "\1\337\46\0\1\340\24\0\1\340\10\0\1\340\25\0"+
    "\1\341\106\0\1\342\21\0\1\342\21\0\1\303\106\0"+
    "\1\304\111\0\1\312\73\0\1\343\24\0\1\343\24\0"+
    "\1\344\100\0\1\345\65\0\1\346\103\0\1\347\22\0"+
    "\1\347\51\0\1\350\73\0\1\351\62\0\1\352\65\0"+
    "\1\353\71\0\1\354\77\0\1\355\107\0\1\356\24\0"+
    "\1\356\25\0\1\357\103\0\1\360\22\0\1\360\51\0"+
    "\1\361\73\0\1\362\55\0\1\363\71\0\1\364\114\0"+
    "\1\365\24\0\1\365\33\0\1\366\75\0\1\367\71\0"+
    "\1\370\35\0\1\370\21\0\1\371\106\0\1\262\22\0"+
    "\1\262\53\0\1\372\21\0\1\372\50\0\1\373\21\0"+
    "\1\373\16\0\1\374\16\0\1\375\27\0\1\375\42\0"+
    "\1\376\27\0\1\376\61\0\1\377\17\0\1\377\5\0"+
    "\21\337\1\u0100\51\337\41\0\1\u0101\21\0\1\u0101\53\0"+
    "\1\u0102\24\0\1\u0102\24\0\1\u0103\110\0\1\u0104\21\0"+
    "\1\u0104\53\0\1\u0105\24\0\1\u0105\17\0\1\u0106\114\0"+
    "\1\u0107\41\0\1\u0108\16\0\1\u0109\27\0\1\u0109\63\0"+
    "\1\u010a\70\0\1\u010b\57\0\1\u010c\24\0\1\u010c\10\0"+
    "\1\u010c\30\0\1\u010d\27\0\1\u010d\61\0\1\u010e\57\0"+
    "\1\u010f\24\0\1\u010f\10\0\1\u010f\43\0\1\u0110\21\0"+
    "\1\u0110\47\0\1\u0111\41\0\1\u0112\16\0\1\u0113\27\0"+
    "\1\u0113\63\0\1\u0114\70\0\1\u0115\53\0\1\u0116\27\0"+
    "\1\u0116\61\0\1\u0117\66\0\1\u0118\21\0\1\u0118\47\0"+
    "\1\u0119\67\0\1\255\67\0\1\u011a\24\0\1\u011a\10\0"+
    "\1\u011a\21\0\1\150\72\0\1\155\54\0\1\374\2\0"+
    "\1\374\1\u011b\3\0\1\u011c\1\u011d\1\u011e\2\u011f\4\0"+
    "\2\u0120\1\u0121\1\u0122\4\u0120\1\u0121\2\u0120\1\u0121\1\u0120"+
    "\1\u0123\1\u0124\1\u0125\1\u0126\1\u0120\1\u0127\1\u0128\1\u0129"+
    "\1\u012a\1\u0121\1\u0120\1\0\2\u0120\1\u0122\3\u0120\1\u0123"+
    "\1\u0124\1\u0125\1\u0120\1\u0128\1\u012b\1\u0120\1\0\1\u012c"+
    "\31\0\1\u012d\77\0\1\u012e\22\0\1\u012e\52\0\1\u012f"+
    "\21\0\1\u012f\31\0\1\u0130\112\0\1\u0131\21\0\1\u0131"+
    "\53\0\1\u0132\24\0\1\u0132\20\0\1\167\114\0\1\u0133"+
    "\21\0\1\u0133\50\0\1\u0134\21\0\1\u0134\52\0\1\u0135"+
    "\30\0\1\u0108\2\0\1\u0108\1\u0136\10\u0137\4\0\15\u0137"+
    "\1\u0138\12\u0137\1\0\6\u0137\1\u0138\6\u0137\33\0\1\u0139"+
    "\70\0\1\u013a\104\0\1\u013b\76\0\1\u013c\24\0\1\u013c"+
    "\36\0\1\u013d\22\0\1\u013d\57\0\1\u013e\51\0\1\u013f"+
    "\27\0\1\u013f\35\0\1\173\116\0\1\u0140\30\0\1\u0112"+
    "\2\0\1\u0112\1\u0141\10\u0142\4\0\15\u0142\1\u0143\12\u0142"+
    "\1\0\6\u0142\1\u0143\6\u0142\33\0\1\u0144\70\0\1\u0145"+
    "\104\0\1\u0146\67\0\1\u0147\22\0\1\u0147\57\0\1\u0148"+
    "\44\0\1\200\112\0\1\u0149\74\0\1\330\21\0\1\330"+
    "\46\0\1\u014a\21\0\1\u014a\22\0\5\u011c\66\0\5\u011f"+
    "\34\0\2\u0120\6\0\1\u0120\21\0\4\u011f\1\u011c\34\0"+
    "\2\u0120\6\0\1\u0120\21\0\5\u011c\34\0\2\u0120\6\0"+
    "\1\u0120\34\0\1\u0121\5\0\1\u0121\2\0\1\u0121\11\0"+
    "\2\u0121\50\0\1\u014b\3\0\1\u014c\5\0\1\u014d\15\0"+
    "\1\u014b\1\u014c\2\0\1\u014d\5\0\1\u014c\42\0\1\u014e"+
    "\21\0\1\u014e\55\0\1\u014f\17\0\1\u014f\50\0\1\u0150"+
    "\20\0\1\u0150\54\0\1\u0151\52\0\1\u0152\27\0\1\u0152"+
    "\42\0\1\u0153\14\0\1\u0154\12\0\1\u0153\5\0\1\u0154"+
    "\45\0\1\u014d\21\0\1\u014d\35\0\1\u0121\1\0\1\u0155"+
    "\3\0\1\u0121\2\0\1\u0121\11\0\2\u0121\5\0\1\u0155"+
    "\42\0\1\u0155\27\0\1\u0155\36\0\1\u0156\30\0\1\u0156"+
    "\54\0\1\u0157\22\0\1\u0157\12\0\20\u0158\1\0\52\u0158"+
    "\17\0\1\222\114\0\1\u0159\21\0\1\u0159\26\0\1\227"+
    "\74\0\1\14\76\0\1\u015a\104\0\1\u015b\21\0\1\u015b"+
    "\17\0\10\u0137\4\0\30\u0137\1\0\15\u0137\11\0\1\u0137"+
    "\1\u015c\6\u0137\4\0\24\u0137\1\u015d\3\u0137\1\0\15\u0137"+
    "\25\0\1\u015e\30\0\1\u015e\56\0\1\u015f\57\0\1\u0160"+
    "\113\0\1\u0161\17\0\1\u0161\42\0\1\u0162\22\0\1\u0162"+
    "\34\0\1\u0163\102\0\1\u0164\24\0\1\u0164\10\0\1\u0164"+
    "\27\0\1\u0165\104\0\1\u0166\21\0\1\u0166\17\0\10\u0142"+
    "\4\0\30\u0142\1\0\15\u0142\11\0\1\u0142\1\u0167\6\u0142"+
    "\4\0\24\u0142\1\u0168\3\u0142\1\0\15\u0142\25\0\1\u0169"+
    "\30\0\1\u0169\56\0\1\u016a\57\0\1\u016b\103\0\1\u016c"+
    "\22\0\1\u016c\34\0\1\u016d\76\0\1\324\67\0\1\u016e"+
    "\73\0\1\u0150\27\0\1\u0150\42\0\1\u016f\27\0\1\u016f"+
    "\43\0\1\u0170\27\0\1\u0170\54\0\1\u0171\21\0\1\u0171"+
    "\56\0\1\u0172\17\0\1\u0172\37\0\1\u0173\24\0\1\u0173"+
    "\10\0\1\u0173\24\0\1\u0174\7\0\1\u0175\20\0\1\u0174"+
    "\3\0\1\u0175\10\0\1\u0175\26\0\1\u0176\1\u0170\16\0"+
    "\1\u0177\1\u0178\6\0\1\u0176\1\u0170\7\0\1\u0178\3\0"+
    "\1\u0177\44\0\1\u0179\20\0\1\u0179\34\0\1\u014d\27\0"+
    "\1\u014d\53\0\1\u017a\21\0\1\u017a\56\0\1\u017b\17\0"+
    "\1\u017b\27\0\1\u017c\30\0\1\u017c\17\0\20\u0158\1\0"+
    "\7\u0158\1\u017d\42\u0158\17\0\1\230\113\0\1\u017e\55\0"+
    "\1\u017f\50\0\1\u0180\2\0\1\u0180\1\u0181\10\u0137\4\0"+
    "\30\u0137\1\0\15\u0137\11\0\10\u0137\4\0\14\u0137\1\u0182"+
    "\13\u0137\1\0\15\u0137\50\0\1\u0183\17\0\1\u0183\56\0"+
    "\1\u0184\61\0\1\u0185\75\0\1\u0186\20\0\1\u0186\30\0"+
    "\1\u0187\30\0\1\u0187\64\0\1\u015a\65\0\1\u0188\21\0"+
    "\1\u0188\50\0\1\u0189\55\0\1\u018a\50\0\1\u018b\2\0"+
    "\1\u018b\1\u018c\10\u0142\4\0\30\u0142\1\0\15\u0142\11\0"+
    "\10\u0142\4\0\14\u0142\1\u018d\13\u0142\1\0\15\u0142\50\0"+
    "\1\u018e\17\0\1\u018e\56\0\1\u018f\61\0\1\u0190\54\0"+
    "\1\u0191\30\0\1\u0191\64\0\1\u0165\71\0\1\u0192\24\0"+
    "\1\u0192\33\0\1\u0193\24\0\1\u0193\10\0\1\u0193\34\0"+
    "\1\u0194\24\0\1\u0194\10\0\1\u0194\2\0\2\u0120\3\0"+
    "\66\u0120\22\0\1\u0195\30\0\1\u0195\55\0\1\u0171\77\0"+
    "\1\u0177\1\0\1\u0196\16\0\1\u0177\1\u0196\44\0\1\u0197"+
    "\21\0\1\u0197\51\0\1\u0198\21\0\1\u0198\55\0\1\u0171"+
    "\17\0\1\u0171\52\0\1\u0150\17\0\1\u0150\56\0\1\u0171"+
    "\15\0\1\u0171\50\0\1\u0199\17\0\1\u0199\45\0\1\u019a"+
    "\16\0\1\u019b\2\0\1\u019c\11\0\1\u017c\2\0\1\u017c"+
    "\1\u019d\3\0\1\u019e\1\u019f\1\u01a0\2\u01a1\4\0\2\u01a2"+
    "\1\u01a3\1\u01a4\4\u01a2\1\u01a3\2\u01a2\1\u01a3\1\u01a2\1\u01a5"+
    "\1\u01a6\1\u01a7\1\u01a8\1\u01a2\1\u01a9\1\u01aa\1\u01ab\1\u01ac"+
    "\1\u01a3\1\u01a2\1\0\2\u01a2\1\u01a4\3\u01a2\1\u01a5\1\u01a6"+
    "\1\u01a7\1\u01a2\1\u01aa\1\u01ad\1\u01a2\1\0\1\u01ae\1\0"+
    "\20\u0158\1\0\7\u0158\1\u017d\15\u0158\1\u01af\24\u0158\44\0"+
    "\1\u01b0\24\0\1\u01b0\40\0\1\u01b1\21\0\1\u01b1\17\0"+
    "\1\u0137\1\u015c\6\u0137\4\0\30\u0137\1\0\15\u0137\43\0"+
    "\1\u01b2\16\0\1\u01b3\2\0\1\u01b4\42\0\1\u01b5\75\0"+
    "\1\u01b6\57\0\1\u01b7\30\0\1\u01b7\20\0\1\u01b8\2\0"+
    "\1\u01b8\1\u01b9\10\u01ba\2\0\1\u01bb\1\0\15\u01ba\1\u01bc"+
    "\12\u01ba\1\0\6\u01ba\1\u01bc\6\u01ba\3\0\20\u01bd\1\0"+
    "\52\u01bd\44\0\1\u01be\24\0\1\u01be\40\0\1\u01bf\21\0"+
    "\1\u01bf\17\0\1\u0142\1\u0167\6\u0142\4\0\30\u0142\1\0"+
    "\15\u0142\43\0\1\u0112\21\0\1\u0112\42\0\1\u01c0\75\0"+
    "\1\u01c1\36\0\1\u0191\2\0\1\u0191\1\u01c2\10\u01c3\4\0"+
    "\15\u01c3\1\u01c4\12\u01c3\1\0\6\u01c3\1\u01c4\6\u01c3\44\0"+
    "\1\u01c5\21\0\1\u01c5\31\0\1\u01c6\15\0\1\u01c7\12\0"+
    "\1\u01c6\6\0\1\u01c7\34\0\1\u01c8\27\0\1\u01c8\65\0"+
    "\1\u0171\16\0\1\u0171\51\0\1\u01c9\17\0\1\u01c9\32\0"+
    "\1\u0170\17\0\1\u0171\7\0\1\u0170\7\0\1\u0171\44\0"+
    "\1\u01ca\21\0\1\u01ca\37\0\1\u01cb\3\0\1\u01cc\13\0"+
    "\1\u01cd\7\0\1\u01cb\1\u01cc\10\0\1\u01cc\3\0\1\374"+
    "\2\0\1\374\1\u011b\3\0\1\u011c\1\u011d\1\u011e\2\u011f"+
    "\2\0\1\u01ce\1\0\2\u0120\1\u0121\1\u0122\4\u0120\1\u0121"+
    "\2\u0120\1\u0121\1\u0120\1\u0123\1\u0124\1\u0125\1\u0126\1\u0120"+
    "\1\u0127\1\u0128\1\u0129\1\u012a\1\u0121\1\u0120\1\0\2\u0120"+
    "\1\u0122\3\u0120\1\u0123\1\u0124\1\u0125\1\u0120\1\u0128\1\u012b"+
    "\1\u0120\1\0\1\u012c\2\0\2\u01cf\1\0\1\u01cf\1\u01d0"+
    "\66\0\1\u01d1\1\u01cf\1\0\1\u01d1\1\u01d2\3\0\1\u011c"+
    "\1\u011d\1\u011e\2\u011f\2\0\1\u01ce\1\0\2\u0120\1\u0121"+
    "\1\u0122\4\u0120\1\u0121\2\u0120\1\u0121\1\u0120\1\u0123\1\u0124"+
    "\1\u0125\1\u0126\1\u0120\1\u0127\1\u0128\1\u0129\1\u012a\1\u0121"+
    "\1\u0120\1\0\2\u0120\1\u0122\3\u0120\1\u0123\1\u0124\1\u0125"+
    "\1\u0120\1\u0128\1\u012b\1\u0120\1\0\1\u012c\40\0\1\u01d3"+
    "\21\0\1\u01d3\22\0\5\u019e\2\0\1\u01ce\63\0\5\u01a1"+
    "\2\0\1\u01ce\31\0\2\u01a2\6\0\1\u01a2\21\0\4\u01a1"+
    "\1\u019e\2\0\1\u01ce\31\0\2\u01a2\6\0\1\u01a2\21\0"+
    "\5\u019e\2\0\1\u01ce\31\0\2\u01a2\6\0\1\u01a2\30\0"+
    "\1\u01ce\72\0\1\u01ce\3\0\1\u01a3\5\0\1\u01a3\2\0"+
    "\1\u01a3\11\0\2\u01a3\42\0\1\u01ce\5\0\1\u01d4\3\0"+
    "\1\u01d5\5\0\1\u01d6\15\0\1\u01d4\1\u01d5\2\0\1\u01d6"+
    "\5\0\1\u01d5\22\0\1\u01ce\17\0\1\u01d7\21\0\1\u01d7"+
    "\30\0\1\u01ce\24\0\1\u01d8\17\0\1\u01d8\25\0\1\u01ce"+
    "\22\0\1\u01d9\20\0\1\u01d9\26\0\1\u01ce\25\0\1\u01da"+
    "\44\0\1\u01ce\5\0\1\u01db\27\0\1\u01db\34\0\1\u01ce"+
    "\5\0\1\u01dc\14\0\1\u01dd\12\0\1\u01dc\5\0\1\u01dd"+
    "\26\0\1\u01ce\16\0\1\u01d6\21\0\1\u01d6\31\0\1\u01ce"+
    "\3\0\1\u01a3\1\0\1\u01de\3\0\1\u01a3\2\0\1\u01a3"+
    "\11\0\2\u01a3\5\0\1\u01de\34\0\1\u01ce\5\0\1\u01de"+
    "\27\0\1\u01de\42\0\1\u01db\27\0\1\u01db\14\0\20\u0158"+
    "\1\0\1\u0158\1\u01df\5\u0158\1\u017d\22\u0158\1\u01df\17\u0158"+
    "\41\0\1\u01e0\21\0\1\u01e0\32\0\1\u01e1\50\0\1\u0108"+
    "\2\0\1\u0108\1\u0136\10\u0137\2\0\1\u01bb\1\0\15\u0137"+
    "\1\u0138\12\u0137\1\0\6\u0137\1\u0138\6\u0137\4\0\2\u01e2"+
    "\1\0\1\u01e2\1\u01e3\66\0\1\u01e4\1\u01e2\1\0\1\u01e4"+
    "\1\u01e5\10\u0137\2\0\1\u01bb\1\0\15\u0137\1\u0138\12\u0137"+
    "\1\0\6\u0137\1\u0138\6\u0137\43\0\1\u01e6\67\0\1\u015a"+
    "\102\0\1\u01e7\17\0\1\u01e7\6\0\1\u01b8\2\0\1\u01b8"+
    "\1\u01b9\10\u01ba\4\0\15\u01ba\1\u01bc\12\u01ba\1\0\6\u01ba"+
    "\1\u01bc\6\u01ba\42\0\1\u01e8\21\0\1\u01e8\17\0\10\u01ba"+
    "\4\0\30\u01ba\1\0\15\u01ba\13\0\1\u01e9\70\0\1\u01ba"+
    "\1\u01ea\6\u01ba\4\0\24\u01ba\1\u01eb\3\u01ba\1\0\15\u01ba"+
    "\44\0\1\u01ec\21\0\1\u01ec\32\0\1\u01ed\107\0\1\u01ee"+
    "\67\0\1\u0165\74\0\1\u01ef\21\0\1\u01ef\17\0\10\u01c3"+
    "\4\0\30\u01c3\1\0\15\u01c3\11\0\1\u01c3\1\u01f0\6\u01c3"+
    "\4\0\24\u01c3\1\u01f1\3\u01c3\1\0\15\u01c3\22\0\1\374"+
    "\112\0\1\u01f2\4\0\1\u01f3\14\0\1\u01f2\7\0\1\u01f3"+
    "\46\0\1\u01f4\17\0\1\u01f4\33\0\1\u01cb\27\0\1\u01cb"+
    "\54\0\1\u01f5\21\0\1\u01f5\35\0\1\u0171\27\0\1\u0171"+
    "\61\0\1\u0150\24\0\1\u0150\25\0\1\u01f6\1\u01f7\14\0"+
    "\1\u01f8\2\0\1\u01f9\6\0\1\u01f6\1\u01f7\7\0\1\u01f9"+
    "\44\0\1\u01c8\21\0\1\u01c8\21\0\1\u01fa\63\0\2\u01cf"+
    "\1\0\1\u01cf\1\u01d0\14\0\1\u01fb\22\0\1\215\5\0"+
    "\1\u01fb\11\0\1\215\44\0\1\u01fc\21\0\1\u01fc\12\0"+
    "\1\u01d1\1\u01cf\1\0\1\u01d1\1\u01d2\3\0\1\u011c\1\u011d"+
    "\1\u011e\2\u011f\4\0\1\u01fd\1\u0120\1\u0121\1\u0122\4\u0120"+
    "\1\u0121\2\u0120\1\u0121\1\u0120\1\u0123\1\u0124\1\u0125\1\u0126"+
    "\1\u0120\1\u0127\1\u01fe\1\u0129\1\u012a\1\u0121\1\u0120\1\0"+
    "\1\u01fd\1\u0120\1\u0122\3\u0120\1\u0123\1\u0124\1\u0125\1\u0120"+
    "\1\u01fe\1\u012b\1\u0120\1\0\1\u012c\40\0\1\u01ff\21\0"+
    "\1\u01ff\34\0\1\u0200\73\0\1\u01d9\27\0\1\u01d9\42\0"+
    "\1\u0201\27\0\1\u0201\43\0\1\u0202\27\0\1\u0202\54\0"+
    "\1\u0203\21\0\1\u0203\56\0\1\u0204\17\0\1\u0204\37\0"+
    "\1\u0205\24\0\1\u0205\10\0\1\u0205\24\0\1\u0206\7\0"+
    "\1\u0207\20\0\1\u0206\3\0\1\u0207\10\0\1\u0207\26\0"+
    "\1\u0208\1\u0202\16\0\1\u0209\1\u020a\6\0\1\u0208\1\u0202"+
    "\7\0\1\u020a\3\0\1\u0209\44\0\1\u020b\20\0\1\u020b"+
    "\34\0\1\u01d6\27\0\1\u01d6\53\0\1\u020c\21\0\1\u020c"+
    "\11\0\20\u0158\1\0\7\u0158\1\u017d\12\u0158\1\u020d\20\u0158"+
    "\1\u020d\6\u0158\17\0\1\u0108\117\0\1\u020e\24\0\1\u020e"+
    "\2\0\2\u01e2\1\0\1\u01e2\1\u01e3\14\0\1\u020f\22\0"+
    "\1\u0210\5\0\1\u020f\11\0\1\u0210\44\0\1\u0211\21\0"+
    "\1\u0211\12\0\1\u01e4\1\u01e2\1\0\1\u01e4\1\u01e5\10\u0137"+
    "\4\0\1\u0212\14\u0137\1\u0138\5\u0137\1\u0213\4\u0137\1\0"+
    "\1\u0212\5\u0137\1\u0138\3\u0137\1\u0213\2\u0137\42\0\1\u0214"+
    "\21\0\1\u0214\50\0\1\u0215\73\0\1\u0216\21\0\1\u0216"+
    "\33\0\1\u0217\100\0\1\u0218\42\0\1\u0219\2\0\1\u0219"+
    "\1\u021a\10\u01ba\4\0\30\u01ba\1\0\15\u01ba\11\0\10\u01ba"+
    "\4\0\14\u01ba\1\u021b\13\u01ba\1\0\15\u01ba\22\0\1\u0112"+
    "\117\0\1\u021c\24\0\1\u021c\40\0\1\u021d\56\0\1\u021e"+
    "\50\0\1\u021f\2\0\1\u021f\1\u0220\10\u01c3\4\0\30\u01c3"+
    "\1\0\15\u01c3\11\0\10\u01c3\4\0\14\u01c3\1\u0221\13\u01c3"+
    "\1\0\15\u01c3\42\0\1\u0222\21\0\1\u0222\55\0\1\u0223"+
    "\24\0\1\u0223\46\0\1\u01c8\17\0\1\u01c8\50\0\1\u014d"+
    "\20\0\1\u014d\40\0\1\u0224\24\0\1\u0224\10\0\1\u0224"+
    "\50\0\1\u01c8\72\0\1\u0225\67\0\1\u0226\20\0\1\u0226"+
    "\37\0\1\u0227\76\0\1\u0228\22\0\1\u0228\35\0\1\u0229"+
    "\71\0\1\267\3\0\1\u0153\14\0\1\u0154\7\0\1\267"+
    "\2\0\1\u0153\5\0\1\u0154\31\0\1\u022a\113\0\1\u022b"+
    "\24\0\1\u022b\33\0\1\u022c\24\0\1\u022c\10\0\1\u022c"+
    "\34\0\1\u022d\24\0\1\u022d\10\0\1\u022d\2\0\2\u01a2"+
    "\3\0\66\u01a2\22\0\1\u022e\30\0\1\u022e\55\0\1\u0203"+
    "\77\0\1\u0209\1\0\1\u022f\16\0\1\u0209\1\u022f\44\0"+
    "\1\u0230\21\0\1\u0230\51\0\1\u0231\21\0\1\u0231\55\0"+
    "\1\u0203\17\0\1\u0203\52\0\1\u01d9\17\0\1\u01d9\56\0"+
    "\1\u0203\15\0\1\u0203\50\0\1\u0232\17\0\1\u0232\5\0"+
    "\20\u0158\1\0\4\u0158\1\u0233\2\u0158\1\u017d\24\u0158\1\u0233"+
    "\15\u0158\41\0\1\u0234\21\0\1\u0234\44\0\1\u0235\22\0"+
    "\1\u0235\34\0\1\u0236\30\0\1\u0236\42\0\1\u0237\55\0"+
    "\10\u0137\4\0\13\u0137\1\u0238\14\u0137\1\0\5\u0137\1\u0238"+
    "\7\u0137\11\0\10\u0137\4\0\1\u0239\27\u0137\1\0\1\u0239"+
    "\14\u0137\26\0\1\u023a\75\0\1\u017e\44\0\20\u023b\1\0"+
    "\52\u023b\44\0\1\u023c\24\0\1\u023c\17\0\1\u023d\113\0"+
    "\1\u023e\21\0\1\u023e\17\0\1\u01ba\1\u01ea\6\u01ba\4\0"+
    "\30\u01ba\1\0\15\u01ba\44\0\1\u023f\21\0\1\u023f\35\0"+
    "\1\u0189\110\0\1\u0240\24\0\1\u0240\40\0\1\u0241\21\0"+
    "\1\u0241\17\0\1\u01c3\1\u01f0\6\u01c3\4\0\30\u01c3\1\0"+
    "\15\u01c3\43\0\1\u0242\21\0\1\u0242\36\0\1\u01c7\27\0"+
    "\1\u01c7\53\0\1\u0243\21\0\1\u0243\33\0\1\u0244\30\0"+
    "\1\u0244\45\0\1\u01c8\27\0\1\u01c8\32\0\1\u0245\111\0"+
    "\1\u0246\22\0\1\u0246\56\0\1\u0247\24\0\1\u0247\45\0"+
    "\1\u0248\24\0\1\u0248\42\0\1\u0249\21\0\1\u0249\31\0"+
    "\1\u024a\15\0\1\u024b\12\0\1\u024a\6\0\1\u024b\34\0"+
    "\1\u024c\27\0\1\u024c\65\0\1\u0203\16\0\1\u0203\51\0"+
    "\1\u024d\17\0\1\u024d\32\0\1\u0202\17\0\1\u0203\7\0"+
    "\1\u0202\7\0\1\u0203\44\0\1\u024e\21\0\1\u024e\37\0"+
    "\1\u024f\3\0\1\u0250\13\0\1\u0251\7\0\1\u024f\1\u0250"+
    "\10\0\1\u0250\2\0\20\u0158\1\0\1\u0158\1\u0252\5\u0158"+
    "\1\u017d\1\u0158\1\u0253\20\u0158\1\u0252\3\u0158\1\u0253\10\u0158"+
    "\1\u0253\2\u0158\17\0\1\u0180\110\0\1\u0254\22\0\1\u0254"+
    "\35\0\1\u0255\113\0\1\u0256\24\0\1\u0256\7\0\10\u0137"+
    "\4\0\13\u0137\1\u0257\14\u0137\1\0\5\u0137\1\u0257\7\u0137"+
    "\11\0\10\u0137\4\0\1\u0137\1\u0258\26\u0137\1\0\15\u0137"+
    "\47\0\1\u0259\24\0\1\u0259\42\0\1\u025a\21\0\1\u025a"+
    "\50\0\1\u025b\21\0\1\u025b\32\0\1\u025c\66\0\1\u018b"+
    "\114\0\1\u025d\21\0\1\u025d\32\0\1\u025e\116\0\1\u01c8"+
    "\16\0\1\u01c8\46\0\1\u01f7\75\0\1\u025f\17\0\1\u025f"+
    "\46\0\1\u0260\21\0\1\u0260\16\0\1\374\16\0\1\u0261"+
    "\27\0\1\u0261\55\0\1\u0262\21\0\1\u0262\50\0\1\u0263"+
    "\21\0\1\u0263\26\0\1\u017c\112\0\1\u0264\4\0\1\u0265"+
    "\14\0\1\u0264\7\0\1\u0265\46\0\1\u0266\17\0\1\u0266"+
    "\33\0\1\u024f\27\0\1\u024f\54\0\1\u0267\21\0\1\u0267"+
    "\35\0\1\u0203\27\0\1\u0203\61\0\1\u01d9\24\0\1\u01d9"+
    "\25\0\1\u0268\1\u0269\14\0\1\u026a\2\0\1\u026b\6\0"+
    "\1\u0268\1\u0269\7\0\1\u026b\44\0\1\u024c\21\0\1\u024c"+
    "\11\0\20\u0158\1\0\7\u0158\1\u017d\13\u0158\1\u026c\24\u0158"+
    "\1\u026c\21\u0158\1\0\1\u0158\1\u0252\5\u0158\1\u017d\22\u0158"+
    "\1\u0252\17\u0158\7\0\1\u0108\16\0\1\u026d\27\0\1\u026d"+
    "\42\0\1\u026e\27\0\1\u026e\55\0\1\u026f\21\0\1\u026f"+
    "\15\0\1\u0137\1\u0270\6\u0137\4\0\4\u0137\1\u0271\23\u0137"+
    "\1\0\3\u0137\1\u0271\11\u0137\11\0\10\u0137\4\0\4\u0137"+
    "\1\u0272\23\u0137\1\0\3\u0137\1\u0272\11\u0137\44\0\1\u0273"+
    "\21\0\1\u0273\26\0\1\u01b8\74\0\1\u0274\115\0\1\u0275"+
    "\24\0\1\u0275\20\0\1\u0191\117\0\1\u0276\24\0\1\u0276"+
    "\46\0\1\u0277\17\0\1\u0277\26\0\1\u0120\101\0\1\u0278"+
    "\61\0\1\u01cf\72\0\1\u01d1\112\0\1\u0279\21\0\1\u0279"+
    "\55\0\1\u027a\24\0\1\u027a\46\0\1\u024c\17\0\1\u024c"+
    "\50\0\1\u01d6\20\0\1\u01d6\40\0\1\u027b\24\0\1\u027b"+
    "\10\0\1\u027b\50\0\1\u024c\72\0\1\u027c\67\0\1\u027d"+
    "\20\0\1\u027d\6\0\20\u0158\1\0\7\u0158\1\u017d\1\u0158"+
    "\1\u027e\24\u0158\1\u027e\10\u0158\1\u027e\2\u0158\30\0\1\u027f"+
    "\77\0\1\u0280\22\0\1\u0280\31\0\1\u01e2\61\0\10\u0137"+
    "\4\0\6\u0137\1\u0281\21\u0137\1\0\15\u0137\11\0\10\u0137"+
    "\4\0\13\u0137\1\u0282\14\u0137\1\0\5\u0137\1\u0282\7\u0137"+
    "\22\0\1\u01e4\114\0\1\u0283\21\0\1\u0283\50\0\1\u0284"+
    "\21\0\1\u0284\52\0\1\u01c8\20\0\1\u01c8\30\0\1\u0285"+
    "\30\0\1\u0285\57\0\1\u0286\21\0\1\u0286\36\0\1\u024b"+
    "\27\0\1\u024b\53\0\1\u0287\21\0\1\u0287\33\0\1\u0288"+
    "\30\0\1\u0288\45\0\1\u024c\27\0\1\u024c\14\0\20\u0158"+
    "\1\0\7\u0158\1\u0289\42\u0158\22\0\1\u028a\30\0\1\u028a"+
    "\54\0\1\u028b\22\0\1\u028b\20\0\10\u0137\4\0\1\u028c"+
    "\27\u0137\1\0\1\u028c\14\u0137\11\0\10\u0137\4\0\13\u0137"+
    "\1\u028d\14\u0137\1\0\5\u0137\1\u028d\7\u0137\22\0\1\u0219"+
    "\72\0\1\u021f\120\0\1\u028e\17\0\1\u028e\54\0\1\u024c"+
    "\16\0\1\u024c\46\0\1\u0269\75\0\1\u028f\17\0\1\u028f"+
    "\5\0\20\u0158\1\0\7\u0158\1\u017d\1\u0158\1\u0290\13\u0158"+
    "\1\u01af\10\u0158\1\u0290\10\u0158\1\u0290\2\u0158\45\0\1\u0291"+
    "\17\0\1\u0291\27\0\1\u01b8\30\0\1\u01b8\25\0\10\u0137"+
    "\4\0\23\u0137\1\u0292\4\u0137\1\0\12\u0137\1\u0292\2\u0137"+
    "\11\0\10\u0137\4\0\1\u0293\27\u0137\1\0\1\u0293\14\u0137"+
    "\43\0\1\374\21\0\1\374\55\0\1\u0294\17\0\1\u0294"+
    "\5\0\20\u0158\1\0\7\u0158\1\u017d\4\u0158\1\u0295\22\u0158"+
    "\1\u0295\12\u0158\40\0\1\u0108\21\0\1\u0108\16\0\10\u0137"+
    "\4\0\16\u0137\1\u0270\11\u0137\1\0\7\u0137\1\u0270\5\u0137"+
    "\4\0\1\u01b8\2\0\1\u01b8\1\u01b9\10\u0137\4\0\15\u0137"+
    "\1\u0296\12\u0137\1\0\6\u0137\1\u0296\6\u0137\46\0\1\u024c"+
    "\20\0\1\u024c\6\0\20\u0158\1\0\7\u0158\1\u017d\4\u0158"+
    "\1\u0297\22\u0158\1\u0297\12\u0158\6\0\1\u0137\1\u0298\6\u0137"+
    "\4\0\24\u0137\1\u0299\3\u0137\1\0\15\u0137\3\0\20\u0158"+
    "\1\0\7\u0158\1\u017d\1\u0158\1\u029a\24\u0158\1\u029a\10\u0158"+
    "\1\u029a\2\u0158\1\0\1\u0219\2\0\1\u0219\1\u021a\10\u0137"+
    "\4\0\30\u0137\1\0\15\u0137\11\0\10\u0137\4\0\14\u0137"+
    "\1\u029b\13\u0137\1\0\15\u0137\3\0\20\u029c\1\0\52\u029c"+
    "\6\0\1\u0137\1\u0298\6\u0137\4\0\30\u0137\1\0\15\u0137"+
    "\3\0\20\u029c\1\u029d\52\u029c\10\0\1\u029e\113\0\1\u029f"+
    "\57\0\1\u02a0\115\0\1\u02a1\21\0\1\u02a1\30\0\1\u02a2"+
    "\51\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[38173];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\11\0\1\11\1\1\1\11\24\1\111\0\1\11\16\0"+
    "\1\1\10\0\1\1\40\0\1\11\25\0\1\11\32\0"+
    "\1\11\44\0\1\11\6\0\1\11\33\0\4\1\1\11"+
    "\13\1\4\0\1\11\6\0\2\1\11\0\2\1\30\0"+
    "\2\1\11\0\2\1\25\0\1\11\3\0\1\1\6\0"+
    "\1\11\3\0\1\1\54\0\1\1\1\0\2\1\5\0"+
    "\2\1\45\0\2\1\4\0\2\1\13\0\2\1\23\0"+
    "\2\1\7\0\1\1\5\0\1\1\26\0\2\1\1\0"+
    "\1\1\33\0\2\1\27\0\3\1\1\0\1\11\14\0"+
    "\2\1\11\0\2\1\4\0\2\1\2\0\1\1\1\0"+
    "\2\1\1\0\1\1\6\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[674];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	SplitDocuments() { }
	
	private int previousState = 0;
	
	private String guardasigilli = "";
	
	String getGuardasigilli() {
		
		return guardasigilli; 
	}
	
	private boolean secondPass = false;
	
	private boolean mainClosed = false;
	
	private String pStart = "";
	
	private int genericAnnexCount = 0;
	
	void setSecondPass(boolean secondPass) {
	
		this.secondPass = secondPass;
	}

	private void readAttachment() {
	
		/* Genera il tag allegato */
	
		//System.out.println("Annex READ: " + yytext());
		
		String originalText = yytext();

		//Lancia il validatore di allegati per decidere se creare il nuovo allegato o ignorare la rilevazione
		
		AnnexHeader v = new AnnexHeader();
		v.setMarkerDocument(getMarkerDocument());
		v.setInput(originalText);
		v.run();
	
		if( !first) output.append("</mrk:allegato>");
			
		first = false;
			
		output.append(v.getOutput());
		
		if(v.getSpaces() > 0) yypushback(v.getSpaces());
	}
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public SplitDocuments(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            switch (zzLexicalState) {
            case inMain: {
              if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		return YYEOF;
            }  // fall though
            case 675: break;
            case inFooter: {
              if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		return YYEOF;
            }  // fall though
            case 676: break;
            case inAttachment: {
              output.append("</mrk:allegato>");
		
		//output.append("</mrk:attachments>");
		
		return YYEOF;
            }  // fall though
            case 677: break;
            default:
              {
                //System.out.println("EOF spaces: \"" + spaces + "\"");

	output.append(spaces);

	return YYEOF;
              }
        }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { System.out.print(yytext());
            }
          // fall through
          case 24: break;
          case 2:
            { output.append(yytext());
            }
          // fall through
          case 25: break;
          case 3:
            { if(getMarkerDocument().isDebug()) System.out.println("{SE} found - CHIUDI MAIN");
		
		if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		output.append(yytext());
            }
          // fall through
          case 26: break;
          case 4:
            { output.append("<mrk:documento>" + yytext());
	 
	yybegin(inMain);
            }
          // fall through
          case 27: break;
          case 5:
            { //Crea comunque un allegato
		
		if(getMarkerDocument().isDebug()) System.out.println("CREA ALLEGATO " + yytext());
		
		if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		//output.append("<mrk:attachments>");
		
		output.append("<mrk:allegato id=\"allegato\">");
		
		yypushback(yylength());
		
		first = false;
		
		yybegin(inAttachment);
            }
          // fall through
          case 28: break;
          case 6:
            { pStart = yytext();
            }
          // fall through
          case 29: break;
          case 7:
            { output.append(yytext());
		yybegin(inFooter);
            }
          // fall through
          case 30: break;
          case 8:
            { output.append(yytext()); previousState = yystate(); yybegin(inPre);
            }
          // fall through
          case 31: break;
          case 9:
            { genericAnnexCount++;

		output.append("<mrk:allegato id=\"allegato-" + genericAnnexCount + "\">" + pStart + "<mrk:intestazione>" + yytext() + "</mrk:intestazione>");
		
		first = false;
		
		yybegin(inAttachment);
            }
          // fall through
          case 32: break;
          case 10:
            { output.append(yytext()); yybegin(previousState);
            }
          // fall through
          case 33: break;
          case 11:
            { output.append(yytext()); previousState = yystate(); yybegin(inTable);
            }
          // fall through
          case 34: break;
          case 12:
            { if(secondPass) {
		
			yypushback(yylength());
			yybegin(inFooter);
			
		} else {
		
			output.append(yytext()); 
		}
            }
          // fall through
          case 35: break;
          case 13:
            { output.append(yytext()); previousState = yystate(); yybegin(inSkip);
            }
          // fall through
          case 36: break;
          case 14:
            { if(getMarkerDocument().isDebug()) System.out.println("ALLEGATO NUMERATO " + yytext());
		
		if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		//output.append("<mrk:attachments>");
		
		getMarkerDocument().getContext().setCurrentPartType("allegato");
		
		readAttachment();
		
		yybegin(inAttachment);
            }
          // fall through
          case 37: break;
          case 15:
            { if(getMarkerDocument().isDebug()) System.out.println("inAnnex ALLEGATO: " + yytext());
		
		getMarkerDocument().getContext().setCurrentPartType("allegato");
		readAttachment();
            }
          // fall through
          case 38: break;
          case 16:
            { if(getMarkerDocument().isDebug()) System.out.println("ALLEGATO SPECIFICO " + yytext());
		
		if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		getMarkerDocument().getContext().setCurrentPartType("allegato");

		//output.append("<mrk:attachments>");
		
		yypushback(yylength());
		yybegin(inGenericAttachment);
            }
          // fall through
          case 39: break;
          case 17:
            { getMarkerDocument().getContext().setCurrentPartType("allegato");
		
		output.append("</mrk:allegato>");
		
		pStart = "";
		
		yypushback(yylength());
		yybegin(inGenericAttachment);
            }
          // fall through
          case 40: break;
          case 18:
            { if(getMarkerDocument().isDebug()) System.out.println("TABELLA NUMERATA " + yytext());
		
		if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }
		
		//output.append("<mrk:attachments>");

		getMarkerDocument().getContext().setCurrentPartType("tabella");
		
		readAttachment();
		
		yybegin(inAttachment);
            }
          // fall through
          case 41: break;
          case 19:
            { if(getMarkerDocument().isDebug()) System.out.println("inFooter UFFICIO: " + yytext());
		
		output.append(yytext());
		yybegin(inUfficio);
            }
          // fall through
          case 42: break;
          case 20:
            { if(getMarkerDocument().isDebug()) System.out.println("inAnnex TABELLA: " + yytext());
		
		getMarkerDocument().getContext().setCurrentPartType("tabella");
		readAttachment();
            }
          // fall through
          case 43: break;
          case 21:
            { if(getMarkerDocument().isDebug()) System.out.println("inFooter REGISTRATO: " + yytext());
		
		output.append(yytext()); 
		yybegin(inRegistrato);
            }
          // fall through
          case 44: break;
          case 22:
            { if(getMarkerDocument().isDebug()) System.out.println("ALLEGATO NON NUMERATO " + yytext());
		
		if( !mainClosed) { output.append("</mrk:documento>"); mainClosed = true; }

		//output.append("<mrk:attachments>");
		
		getMarkerDocument().getContext().setCurrentPartType("allegato");
		
		readAttachment();
		
		yybegin(inAttachment);
            }
          // fall through
          case 45: break;
          case 23:
            { if(getMarkerDocument().isDebug()) System.out.println("Guardasigilli found.");
		
		guardasigilli = yytext();
		
		output.append(yytext());
		yybegin(inFooter);
            }
          // fall through
          case 46: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java SplitDocuments [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        SplitDocuments scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new SplitDocuments(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
